SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #CartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CartTest class methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
newNonEmptyCart

	^ self newEmptyCart add: self bookIsbn1 quantity: 3.! !

!CartTest methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/13/2012 16:15'!
aBookIsbnOutOfEditorial

	^ 'this book isbn is not in the Editorial'.! !

!CartTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:32'!
bookIsbn1
	
	^ 'bookIsbn1'.! !

!CartTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbn2
	
	^ 'bookIsbn2'.! !

!CartTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbn3
	
	^ 'bookIsbn3'.! !

!CartTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbnsOfEditorial

	^ Set with: self bookIsbn1 with: self bookIsbn2 with: self bookIsbn3.! !

!CartTest methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 16:18'!
canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage

	^ 'the specified quantity must be greater than zero'.! !

!CartTest methodsFor: 'error' stamp: 'GrossodelSel 6/18/2012 17:34'!
canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage
	
	^ 'the specified product is invalid'.! !

!CartTest methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
newCartWithOneCopyOfEachBookIsbn

	| cart |
	cart := self newEmptyCart.
	
	self bookIsbnsOfEditorial do:
		[ :aBookIsbn | cart add: aBookIsbn quantity: 1 ].
	
	^ cart.! !

!CartTest methodsFor: 'cart' stamp: 'GrossodelSel 6/18/2012 17:33'!
newEmptyCart

	^ Cart withValidProducts: self bookIsbnsOfEditorial.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/15/2012 16:38'!
test01CartShouldBeEmptyAfterCreation

	self assert: self newEmptyCart isEmpty.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/15/2012 16:38'!
test02CartShouldNotBeEmptyAfterAddingABookIsbnOfTheEditorial
	
	| cart |
	cart := self newEmptyCart.
	
	cart add: (self bookIsbn1) quantity: 1.
	
	self deny: cart isEmpty.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:10'!
test03CartProductsShouldRemainAfterAddingABookIsbnOfTheEditorial

	| cart |
	cart := self newEmptyCart.
	cart add: (self bookIsbn1) quantity: 3.
	cart add: (self bookIsbn2) quantity: 2.
	cart add: (self bookIsbn3) quantity: 1.
	
	self assert: (cart quantityOf: self bookIsbn1) = 3.
	self assert: (cart quantityOf: self bookIsbn2) = 2.
	self assert: (cart quantityOf: self bookIsbn3) = 1.
	
	self assert: cart products size = 6.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:18'!
test04CartsCanBeComparedWithEquals

	| emptyCart nonEmptyCart |
	emptyCart := self newEmptyCart.
	nonEmptyCart := self newCartWithOneCopyOfEachBookIsbn.
	
	self assert: emptyCart = emptyCart.
	self assert: nonEmptyCart = nonEmptyCart.
	self assert: self newEmptyCart = self newEmptyCart.
	self assert: self newCartWithOneCopyOfEachBookIsbn = self newCartWithOneCopyOfEachBookIsbn.
	
	self deny: self newEmptyCart = self newCartWithOneCopyOfEachBookIsbn.
	self deny: self newCartWithOneCopyOfEachBookIsbn = self newEmptyCart.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 17:48'!
test05CanNotAddAnInvalidQuantityOfBookIsbnsToCart
	
	| anEmptyCart aNonEmptyCart |
	
	"Emtpy cart test"
	anEmptyCart := self newEmptyCart.
	self should: [ anEmptyCart add: self bookIsbn2 quantity: -1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage).
			self assert: (anEmptyCart = self newEmptyCart) ].
	
	
	"Non empty cart test"
	aNonEmptyCart := self newCartWithOneCopyOfEachBookIsbn.
	
	self should: [ aNonEmptyCart add: self bookIsbn2 quantity: -1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage).
			self assert: aNonEmptyCart = self newCartWithOneCopyOfEachBookIsbn ].
! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 17:48'!
test06CanNotAddToCartABookIsbnThatIsNotFromTheEditorial
	
	| anEmptyCart aNonEmptyCart |
	
	"Emtpy cart test"
	anEmptyCart := self newEmptyCart.
	self should: [ anEmptyCart add: (self aBookIsbnOutOfEditorial) quantity: 1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage).
			self assert: (anEmptyCart = self newEmptyCart) ].
	
	
	"Non empty cart test"
	aNonEmptyCart := self newCartWithOneCopyOfEachBookIsbn.
	
	self should: [ aNonEmptyCart add: (self aBookIsbnOutOfEditorial) quantity: 1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage).
			self assert: (aNonEmptyCart = self newCartWithOneCopyOfEachBookIsbn) ].
! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 17:48'!
test07CartShouldContainTheSameAmountOfAGivenBookIsbnThatWasAdded
	
	| cart |
	cart := self newEmptyCart.
	
	cart add: self bookIsbn1 quantity: 2.
	self assert: (cart quantityOf: self bookIsbn1) = 2.
	
	cart add: self bookIsbn1 quantity: 3.
	self assert: (cart quantityOf: self bookIsbn1) = 5.
	
	self assert: (cart quantityOf: self bookIsbn2) = 0.! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:42'!
test08CartCanBeEnumeratedUsingDo

	| initialSetOfBookIsbns enumeratedSetOfBookIsbns cart counter |
	
	initialSetOfBookIsbns := self bookIsbnsOfEditorial.
	enumeratedSetOfBookIsbns := Set new.
	cart := self newCartWithOneCopyOfEachBookIsbn.
	
	cart do: [ :aBookIsbn |
		enumeratedSetOfBookIsbns add: aBookIsbn ].
	
	"enumeracin de un carrito con una repeticin de cada producto"
	self assert: initialSetOfBookIsbns = enumeratedSetOfBookIsbns.
	
	
	"enumeracin de un carrito con ms de una repeticin"
	cart add: self bookIsbn1 quantity: 3.
	counter := 0.
	cart do: [ :aProduct | counter := counter + 1 ].
	
	self assert: counter = ( initialSetOfBookIsbns size + 3 ).! !

!CartTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:43'!
test09CartCanBeEnumeratedUsingDistinctProductsDo

	| initialSetOfBookIsbns enumeratedSetOfBookIsbns cart counter |
	
	initialSetOfBookIsbns := self bookIsbnsOfEditorial.
	enumeratedSetOfBookIsbns := Set new.
	cart := self newCartWithOneCopyOfEachBookIsbn.
	
	cart distinctProductsDo: [ :aBookIsbn |
		enumeratedSetOfBookIsbns add: aBookIsbn ].
	
	"enumeracin de un carrito con una repeticin de cada producto"
	self assert: initialSetOfBookIsbns = enumeratedSetOfBookIsbns.
	
	
	"enumeracin de un carrito con ms de una repeticin"
	cart add: self bookIsbn1 quantity: 3.
	counter := 0.
	cart distinctProductsDo: [ :aProduct | counter := counter + 1 ].
	
	self assert: counter = initialSetOfBookIsbns size.! !

TestCase subclass: #CashierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CashierTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/15/2012 18:14'!
bookIsbn1
	
	^ 'bookIsbn1'.! !

!CashierTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/15/2012 18:14'!
bookIsbn2
	
	^ 'bookIsbn2'.! !

!CashierTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/15/2012 18:14'!
bookIsbn3
	
	^ 'bookIsbn3'.! !

!CashierTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/15/2012 18:14'!
bookIsbnsOfEditorial

	^ Set with: self bookIsbn1 with: self bookIsbn2 with: self bookIsbn3.! !

!CashierTest methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 18:26'!
canNotCheckOutAnEmptyCartErrorMessage
	
	^ 'Can not check out an empty cart'.! !

!CashierTest methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 18:38'!
canNotCheckOutWithExpiredCreditCardErrorMessage

	^ 'Can not check out with expired credit card'.! !

!CashierTest methodsFor: 'client' stamp: 'GrossodelSel 6/25/2012 16:10'!
juan

	^ 'Juan'.! !

!CashierTest methodsFor: 'credit-card' stamp: 'GrossodelSel 6/25/2012 16:11'!
juansExpiredCreditCard

	^ CreditCard ownedBy: self juan identifiedBy: 42 expiresOn: (MonthOfYear onMonthNumber: 1 of: Date today year - 1).! !

!CashierTest methodsFor: 'credit-card' stamp: 'GrossodelSel 6/25/2012 16:11'!
juansValidCreditCard

	^ CreditCard ownedBy: self juan identifiedBy: 42 expiresOn: (MonthOfYear onMonthNumber: 1 of: Date today year + 1).! !

!CashierTest methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 18:13'!
newCartWithOneCopyOfEachBookIsbn

	| cart |
	cart := self newEmptyCart.
	
	self bookIsbnsOfEditorial do:
		[ :aBookIsbn | cart add: aBookIsbn quantity: 1 ].
	
	^ cart.! !

!CashierTest methodsFor: 'cashier' stamp: 'GrossodelSel 6/18/2012 20:31'!
newCashier
	
	^ Cashier withCatalog: self newCatalog merchantProcessor: self newDummyMerchantProcessorStub.! !

!CashierTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/18/2012 17:14'!
newCatalog

	| catalog |
	
	catalog := Catalog new.
	catalog add: self bookIsbn1 priced: 10.
	catalog add: self bookIsbn2 priced: 20.
	catalog add: self bookIsbn3 priced: 50.
	
	^ catalog.! !

!CashierTest methodsFor: 'merchant-processor' stamp: 'GrossodelSel 6/18/2012 20:45'!
newDummyMerchantProcessorStub
	
	^ MerchantProcessorStub withActionForDebit: [ :param1 :param2 ].! !

!CashierTest methodsFor: 'cart' stamp: 'GrossodelSel 6/18/2012 17:33'!
newEmptyCart

	^ Cart withValidProducts: self bookIsbnsOfEditorial.! !

!CashierTest methodsFor: 'sales-book' stamp: 'GrossodelSel 6/25/2012 16:20'!
newEmptySalesBook

	^ SalesBook new.! !

!CashierTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:27'!
test01CashierCanNotCheckOutAnEmptyCart

	| cashier creditCardUses |
	
	creditCardUses := 0.
	cashier :=  Cashier withCatalog: self newCatalog salesBook: self newEmptySalesBook  merchantProcessor: (MerchantProcessorStub withActionForDebit: [ creditCardUses := creditCardUses + 1 ] ).
	
	self should: [ cashier checkOutCart: self newEmptyCart forClient: self juan withCreditCard: self juansValidCreditCard ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotCheckOutAnEmptyCartErrorMessage).
			self assert: creditCardUses = 0 ].! !

!CashierTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:28'!
test02CashierCanNotCheckOutWithExpiredCreditCard

	| cashier creditCardUses |
	
	creditCardUses := 0.
	cashier :=  Cashier withCatalog: self newCatalog salesBook: self newEmptySalesBook merchantProcessor: (MerchantProcessorStub withActionForDebit: [ creditCardUses := creditCardUses + 1 ] ).

	self should: [ cashier checkOutCart: self newCartWithOneCopyOfEachBookIsbn forClient: self juan withCreditCard: self juansExpiredCreditCard ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotCheckOutWithExpiredCreditCardErrorMessage).
			self assert: 0 = creditCardUses ].! !

!CashierTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:28'!
test03CashierShouldChargeTheCorrectAmountOfMoney

	| cashier catalog cart totalPrice |

	cart := self newCartWithOneCopyOfEachBookIsbn.
	catalog := self newCatalog.

	totalPrice := 0.
	cart do: [ :aProduct | totalPrice := totalPrice + (catalog priceOf: aProduct) ].
	
	cashier := Cashier withCatalog: catalog salesBook: self newEmptySalesBook merchantProcessor: ( MerchantProcessorStub withActionForDebit: [ :anAmount :aDebitCard | self assert: totalPrice = anAmount  ] ).
	cashier checkOutCart: cart forClient: self juan withCreditCard: self juansValidCreditCard.
	! !

!CashierTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:29'!
test04CashierShouldUpdateSalesBookOnCheckOut

	| cashier catalog cart salesBook juanProducts |
	
	cart := self newCartWithOneCopyOfEachBookIsbn.
	catalog := self newCatalog.
	salesBook := self newEmptySalesBook.
	
	cashier := Cashier withCatalog: catalog salesBook: salesBook merchantProcessor: self newDummyMerchantProcessorStub.
	cashier checkOutCart: cart forClient: self juan withCreditCard: self juansValidCreditCard.
	
	self deny: salesBook isEmpty.
	juanProducts := salesBook productsOfClient: self juan.
	self assert: ( juanProducts allSatisfy: [ :aProduct | ( juanProducts occurrencesOf: aProduct ) = ( cart quantityOf: aProduct ) ] ).! !

!CashierTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:59'!
test05CashierShouldNotLogSaleWhenMerchantProcessorFails

	| cashier catalog cart salesBook |
	
	cart := self newCartWithOneCopyOfEachBookIsbn.
	catalog := self newCatalog.
	salesBook := self newEmptySalesBook.
	
	cashier := Cashier withCatalog: catalog salesBook: salesBook merchantProcessor: ( MerchantProcessorStub withActionForDebit: [ :anAmount :aDebitCard | Error new signal ] ).
	self should: [ cashier checkOutCart: self newEmptyCart withCreditCard: self juansValidCreditCard ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: salesBook isEmpty ].! !

TestCase subclass: #CatalogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CatalogTest methodsFor: 'catalog' stamp: 'GrossodelSel 6/18/2012 17:40'!
newEmptyCatalog

	^ Catalog new.! !

!CatalogTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:05'!
test01CatalogShouldBeEmptyWhenCreated

	self assert: self newEmptyCatalog isEmpty.! !

!CatalogTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:05'!
test02CatalogShouldNotBeEmptyAfterAddingAnElement

	self deny: (self newEmptyCatalog add: 'product0' priced: 100) isEmpty.! !

!CatalogTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:06'!
test03CatalogSetsAProductsPriceWhenAdded

	| catalog product price |
	
	product := 'product0'.
	price := 100.
	catalog := self newEmptyCatalog.
	catalog add: product priced: price.
	
	self assert: (catalog priceOf: product) = price.! !

!CatalogTest methodsFor: 'test' stamp: 'GrossodelSel 6/18/2012 18:11'!
test04CatalogProductsShouldRemainAfterAddingANewOne

	| catalog product1 product2 product3 product1Price product2Price product3Price |
	
	product1 := 'product1'.
	product2 := 'product2'.
	product3 := 'product3'.
	product1Price := 10.
	product2Price := 20.
	product3Price := 50.
	
	catalog := self newEmptyCatalog.
	catalog add: product1 priced: product1Price.
	catalog add: product2 priced: product2Price.
	catalog add: product3 priced: product3Price.
	
	self assert: (catalog priceOf: product1) = product1Price.
	self assert: (catalog priceOf: product2) = product2Price.
	self assert: (catalog priceOf: product3) = product3Price.
	
	self assert: (catalog products size) = 3.! !

TestCase subclass: #MerchantProcessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorTest methodsFor: 'credit-card' stamp: 'GrossodelSel 6/25/2012 17:40'!
pepeSanchezCreditCard

	^ CreditCard ownedBy: 'PEPE SANCHEZ' identifiedBy: 5400000000000001 expiresOn: ( MonthOfYear onMonthNumber: 07 of: 2011 ).! !

!MerchantProcessorTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 18:15'!
test01MerchantProcessorGeneratesWellFormedUrlForDebitRequest

	| creditCard expectedUrl |
	creditCard := self pepeSanchezCreditCard.
	expectedUrl := 'https://merchant.com/debit?creditCardNumber=5400000000000001&creditCardExpiration=072011&creditCardOwner=PEPE%20SANCHEZ&transactionAmount=123.50'.
	
	self assert: ( MerchantProcessor new generateDebitUrlForAmount: 123.50 creditCard: creditCard ) = expectedUrl.! !

TestCase subclass: #SalesBookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!SalesBookTest methodsFor: 'sales-book' stamp: 'GrossodelSel 6/25/2012 14:58'!
newEmptySalesBook

	^ SalesBook new.! !

!SalesBookTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 14:58'!
test01SalesBookShouldBeEmptyAfterCreation

	self assert: self newEmptySalesBook isEmpty.! !

!SalesBookTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 15:18'!
test02SalesBookShouldNotBeEmptyAfterLoggingASale

	| salesBook |
	salesBook := self newEmptySalesBook.
	salesBook logSaleOfProduct: 'prod' quantity: 3 forClient: 'juan'.
	
	self deny: salesBook isEmpty.! !

!SalesBookTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 15:43'!
test03SalesBookProductsForClientShouldBeEmptyBeforeLoggingASale

	| salesBook |
	salesBook := self newEmptySalesBook.
	
	self assert: ( salesBook productsOfClient: 'plinplin' ) isEmpty.! !

!SalesBookTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:48'!
test04SalesBookShouldContainLoggedProductsForClient

	| salesBook juanProducts juan |
	salesBook := self newEmptySalesBook.
	juan := 'juan'.
	juanProducts := Bag new.
	juanProducts add: 'prod1' withOccurrences: 3.
	juanProducts add: 'prod2' withOccurrences: 4.
	
	juanProducts valuesAndCounts keysDo: [ :aProduct | salesBook logSaleOfProduct: aProduct quantity: ( juanProducts occurrencesOf: aProduct ) forClient: juan ].
	
	self assert: ( salesBook productsOfClient: juan ) = juanProducts.! !

!SalesBookTest methodsFor: 'test' stamp: 'GrossodelSel 6/25/2012 16:54'!
test05SalesBookCanLogMultipleProductsAtOnce

	| salesBook juanProducts juan |
	salesBook := self newEmptySalesBook.
	juan := 'juan'.
	juanProducts := Bag new.
	juanProducts add: 'prod1' withOccurrences: 3.
	juanProducts add: 'prod2' withOccurrences: 4.
	
	salesBook logSales: juanProducts forClient: juan.
	
	self assert: ( salesBook productsOfClient: juan ) = juanProducts.! !

Object subclass: #Cart
	instanceVariableNames: 'products validProducts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/18/2012 17:33'!
withValidProducts: aSetOfProducts

	^ Cart new initializeWithValidProducts: aSetOfProducts.! !

!Cart methodsFor: 'comparing' stamp: 'GrossodelSel 6/18/2012 17:30'!
= anotherObject

	(self class = anotherObject class) ifFalse: [ ^ false ].
	
	^ (products = anotherObject products) and: [ validProducts = anotherObject validProducts ].! !

!Cart methodsFor: 'adding' stamp: 'GrossodelSel 6/18/2012 17:32'!
add: aProduct quantity: aQuantity

	(aQuantity <= 0) ifTrue:
		[ self error: self invalidQuantityErrorMessage ].
	
	(validProducts includes: aProduct) ifFalse:
		[ self error: self invalidProductErrorMessage ].
	
	products add: aProduct withOccurrences: aQuantity.! !

!Cart methodsFor: 'enumerating' stamp: 'GrossodelSel 6/25/2012 16:33'!
distinctProductsDo: aBlock

	products valuesAndCounts keysDo: aBlock.! !

!Cart methodsFor: 'enumerating' stamp: 'GrossodelSel 6/25/2012 16:33'!
do: aBlock

	products do: aBlock.! !

!Cart methodsFor: 'initializing' stamp: 'GrossodelSel 6/18/2012 17:32'!
initializeWithValidProducts: aSetOfProducts

	products := Bag new.
	validProducts := aSetOfProducts.! !

!Cart methodsFor: 'error' stamp: 'GrossodelSel 6/18/2012 17:32'!
invalidProductErrorMessage

	^ 'the specified product is invalid'.! !

!Cart methodsFor: 'error' stamp: 'GrossodelSel 6/13/2012 16:04'!
invalidQuantityErrorMessage

	^ 'the specified quantity must be greater than zero'.! !

!Cart methodsFor: 'testing' stamp: 'GrossodelSel 6/18/2012 17:27'!
isEmpty

	^ products isEmpty.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 17:55'!
products

	^ Bag newFrom: products.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 17:33'!
quantityOf: aProduct 

	^ products occurrencesOf: aProduct.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 17:30'!
validProducts

	^ validProducts! !

Object subclass: #Cashier
	instanceVariableNames: 'catalog merchantProcessor salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 18:42'!
canNotCheckOutAnEmptyCartErrorMessage

	^ 'Can not check out an empty cart'.! !

!Cashier class methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 18:41'!
canNotCheckOutWithExpiredCreditCardErrorMessage

	^ 'Can not check out with expired credit card'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/25/2012 16:25'!
withCatalog: aCatalog salesBook: aSalesBook merchantProcessor: aMerchantProcessor

	^ Cashier new initializeWithCatalog: aCatalog salesBook: aSalesBook merchantProcessor: aMerchantProcessor.! !

!Cashier methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 20:57'!
catalog

	^ catalog! !

!Cashier methodsFor: 'check-out' stamp: 'GrossodelSel 6/25/2012 16:54'!
checkOutCart: aCart forClient: aClient withCreditCard: aCreditCard

	| amount |
	
	(aCart isEmpty)
		ifTrue: [ self error:  Cashier canNotCheckOutAnEmptyCartErrorMessage].
	
	(self isExpired: aCreditCard)
		ifTrue: [ self error:  Cashier canNotCheckOutWithExpiredCreditCardErrorMessage].
	
	amount := 0.
	aCart do: [ :anElementOfTheCart |  amount := amount + (self priceOf: anElementOfTheCart) ].
	
	self debit: amount fromCreditCard: aCreditCard.
	
	salesBook logSales: aCart forClient: aClient.! !

!Cashier methodsFor: 'merchant-processor' stamp: 'GrossodelSel 6/18/2012 20:24'!
debit: anAmount fromCreditCard: aCreditCard 

	 ^ merchantProcessor debit: anAmount fromCreditCard: aCreditCard.
! !

!Cashier methodsFor: 'initializing' stamp: 'GrossodelSel 6/15/2012 17:53'!
initialize

	creditCardUses := 0.! !

!Cashier methodsFor: 'initializing' stamp: 'GrossodelSel 6/25/2012 16:24'!
initializeWithCatalog: aCatalog salesBook: aSalesBook merchantProcessor: aMerchantProcessor

	catalog := aCatalog.
	salesBook := aSalesBook.
	merchantProcessor := aMerchantProcessor.! !

!Cashier methodsFor: 'credit-card' stamp: 'GrossodelSel 6/15/2012 18:25'!
isExpired: aCreditCard 

	| today |
	
	today := Date today.

	^ aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: today monthIndex of: today year).
	
! !

!Cashier methodsFor: 'check-out' stamp: 'GrossodelSel 6/18/2012 17:21'!
priceOf: aProduct
	
	^ catalog priceOf: aProduct.! !

Object subclass: #Catalog
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Catalog methodsFor: 'comparing' stamp: 'GrossodelSel 6/18/2012 20:54'!
= anotherObject
	
	
	(self class = anotherObject class) ifFalse: [ ^ false ].
	
	^ (products = anotherObject products).! !

!Catalog methodsFor: 'adding' stamp: 'GrossodelSel 6/18/2012 17:10'!
add: aProduct priced: aPrice

	products at: aProduct put: aPrice.! !

!Catalog methodsFor: 'initializing' stamp: 'GrossodelSel 6/18/2012 17:11'!
initialize

	products := Dictionary new.! !

!Catalog methodsFor: 'testing' stamp: 'GrossodelSel 6/18/2012 17:38'!
isEmpty

	^ products isEmpty.! !

!Catalog methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 17:13'!
priceOf: aProduct

	^ products at: aProduct.! !

!Catalog methodsFor: 'accessing' stamp: 'GrossodelSel 6/18/2012 17:12'!
products

	^ products keys.! !

Object subclass: #MerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessor methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/25/2012 17:18'!
debit: anAmount fromCreditCard: aCreditCard

	self generateDebitUrlForAmount: anAmount creditCard: aCreditCard.! !

!MerchantProcessor methodsFor: 'url' stamp: 'GrossodelSel 6/25/2012 18:15'!
generateDebitUrlForAmount: anAmount creditCard: aCreditCard

	| url expirationDate |
	expirationDate := aCreditCard expirationDate.
	url := 'https://merchant.com/debit?'.
	url := url , 'creditCardNumber=', aCreditCard number asString.
	url := url , '&creditCardExpiration=' , ( expirationDate monthNumber printPaddedWith: $0 to: 2 ) , 
		expirationDate yearNumber asString.
	url := url , '&creditCardOwner=' , ( aCreditCard ownerName encodeForHTTP truncateTo: 30 ).
	url := url , '&transactionAmount=' , ( anAmount printPaddedWith: $0 to: 0.2 ).
	
	^ url.! !

Object subclass: #MerchantProcessorStub
	instanceVariableNames: 'actionForDebit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorStub class methodsFor: 'initializing' stamp: 'GrossodelSel 6/18/2012 20:34'!
withActionForDebit: aBlockForDebit

	^ MerchantProcessorStub new initializeWithActionForDebit: aBlockForDebit.! !

!MerchantProcessorStub methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/18/2012 20:23'!
debit: anAmount fromCreditCard: aCreditCard

	^ actionForDebit value: anAmount value: aCreditCard.! !

!MerchantProcessorStub methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/18/2012 20:22'!
initializeWithActionForDebit: aBlockForDebit

	actionForDebit := aBlockForDebit.! !

Object subclass: #SalesBook
	instanceVariableNames: 'clientProducts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!SalesBook methodsFor: 'initializing' stamp: 'GrossodelSel 6/25/2012 15:27'!
initialize

	clientProducts := Dictionary new.! !

!SalesBook methodsFor: 'testing' stamp: 'GrossodelSel 6/25/2012 15:28'!
isEmpty

	^ clientProducts isEmpty.! !

!SalesBook methodsFor: 'adding' stamp: 'GrossodelSel 6/25/2012 15:56'!
logSaleOfProduct: aProduct quantity: aQuantity forClient: aClient

	| aClientProducts |
	
	aClientProducts := clientProducts at: aClient ifAbsent: [ aClientProducts := Bag new ].
	
	aClientProducts add: aProduct withOccurrences: aQuantity.
	
	clientProducts at: aClient put: aClientProducts.! !

!SalesBook methodsFor: 'adding' stamp: 'GrossodelSel 6/25/2012 16:52'!
logSales: aCollectionOfSales forClient: aClient

	aCollectionOfSales do: [ :aProduct | self logSaleOfProduct: aProduct quantity: 1 forClient: aClient ].! !

!SalesBook methodsFor: 'accessing' stamp: 'GrossodelSel 6/25/2012 15:47'!
productsOfClient: aClient

	^ clientProducts at: aClient ifAbsent: [ ^ Bag new ].! !
